%if "%{?dist}" == ""
%{warn:You must define dist when building this package, expected values are .fcN, .elN, .slesN\n}
%endif

Name:           dell-hw-indep-repository
Version:        1
Release:        10%{?dist}
Summary:        linux.dell.com Dell Repository Configuration
Group:          System Environment/Base
License:        BSD
URL:            http://linux.dell.com
Source0:        RPM-GPG-KEY-dell
Source1:        RPM-GPG-KEY-libsmbios
Source2:        %{name}.repo
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

%description
Contains repository setup for the hardware-independent part of the
linux.dell.com repositories.

This package contains the yum-configuration and the gpg-key for the
linux.dell.com repository.

%prep
%build
%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pki/rpm-gpg/

install -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{_sysconfdir}/pki/rpm-gpg/
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/pki/rpm-gpg/

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/

DIST=%{dist}
# drop leading '.', if present
if [ "${DIST:0:1}" = "." ]; then
    DIST=${DIST:1}
fi

case "${DIST}" in 
  fc*)
  DIST='fc$releasever'
  ;;
  el4)
  DIST='el4'
  ;;
  el[35])
  DIST='el$releasever'
  ;;
  el*)
  DIST='el$releasever'
  ;;
  sles9)
  DIST='sles9'
  ;;
  sles10)
  DIST='sles10'
  ;;
  sles*)
  DIST='sles$releasever'
  ;;
  *)
  # don't change DIST
  ;;
esac

sed -e "s/%DIST%/${DIST}/g" %{SOURCE2} > $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/%{name}.repo
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/%{name}.repo

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
    rm -rf $RPM_BUILD_ROOT
fi


%files
%defattr(-,root,root,-)
%{_sysconfdir}/pki/rpm-gpg/*
%config(noreplace) %{_sysconfdir}/yum.repos.d/*


%post
# bootstrap script is responsible for laying down /etc/dell-mirror.cfg 
# before we run
HARDWARE_SERVER="http://linux.dell.com"
HARDWARE_REPO_URL="/repo/hardware"
[ ! -e /etc/dell-mirror.cfg ] || . /etc/dell-mirror.cfg

# fixup yum config for mirror mode:
if [ -e /etc/dell-mirror.cfg -a "$PUBLIC_HARDWARE_REPO_URL" != "$HARDWARE_REPO_URL" ]; then
  perl -p -i -e "s|$PUBLIC_HARDWARE_REPO_URL|$HARDWARE_REPO_URL|g;" /etc/yum.repos.d/%{name}.repo
fi
if [ -e /etc/dell-mirror.cfg -a "$PUBLIC_HARDWARE_SERVER" != "$HARDWARE_SERVER" ]; then
  perl -p -i -e "s|$PUBLIC_HARDWARE_SERVER|$HARDWARE_SERVER|g;" /etc/yum.repos.d/%{name}.repo
fi

FULL_URL=$(grep ^mirrorlist= %{_sysconfdir}/yum.repos.d/%{name}.repo | cut -d= -f2- )

# we need to update up2date config here
RHN_SOURCES=/etc/sysconfig/rhn/sources
if [ -e ${RHN_SOURCES} ]; then
  if ! grep -q "^#DONT UPDATE %{name}" ${RHN_SOURCES} > /dev/null 2>&1; then
    # remove existing config
    perl -n -i -e 'print if not /^#BEGIN %{name}/ ... /^#END %{name}/' ${RHN_SOURCES}
  
    # add updated config unless user specifies not to
    echo "#BEGIN %{name}" >> ${RHN_SOURCES}
    echo "# This block is managed by the %{name} RPM." >> ${RHN_SOURCES}
    echo "" >> ${RHN_SOURCES}
    echo "yum %{name} ${FULL_URL}&redirect=1&redir_path=" >> ${RHN_SOURCES}
    echo "yum-mirror %{name} $FULL_URL" >> ${RHN_SOURCES}
    echo "" >> ${RHN_SOURCES}
    echo "#END %{name}" >> ${RHN_SOURCES}
  fi
  echo "If you haven't already done so, you should import Dell's GPG keys"
  echo "into RPM.  Do this by running:"
  echo "    rpm --import %{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-dell"
  echo "    rpm --import %{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-libsmbios"
fi

# cannot add sles rug config here as it crashes zlm
# have to do it in the bootstrap script (not optimal)


%postun
RHN_SOURCES=/etc/sysconfig/rhn/sources
if [ $1 = 0 ]; then
  # remove up2date config here
  if [ -e $RHN_SOURCES ]; then 
    perl -n -i -e 'print if not /^#BEGIN %{name}/ ... /^#END %{name}/' ${RHN_SOURCES}
  fi
fi	


%changelog
* Wed Jun 20 2007 Michael E Brown <Michael_E_Brown@dell.com> - 1-0
- initial release
